﻿/*
 * Copyright (c) 2013 CodingBlocks.NET <http://codingblocks.net>, Michael Outlaw <michael@michaeloutlaw.com>
 * 
 * See the file license.txt for copying permission.
 */

using System;
using System.Collections.Generic;

namespace BadEIMIExamples
{
    public class Example
    {
        protected static void SomeExample(Type t)
        {
            Console.Clear();

            var random = new Random();
            var list = new List<SomeClass>();
            for (var i = 0; i < 10; i++)
            {
                var sometype = (SomeClass) Activator.CreateInstance(t);
                sometype.SomeData = random.Next();
                list.Add(sometype);
            }

            Console.WriteLine("Before IComparable comparisons of {0}.", t);
            list.ForEach(x => Console.WriteLine(x.SomeData.ToString("N0")));

            Console.WriteLine("\nWhich IComparable was called?...");
            list.Sort();

            Console.WriteLine("\nAfter IComparable comparisons of {0}.", t);
            list.ForEach(x => Console.WriteLine(x.SomeData.ToString("N0")));

            Console.WriteLine("\nPress ENTER to continue...");
            Console.ReadLine();
        }
    }
}
