﻿/*
 * Copyright (c) 2013 CodingBlocks.NET <http://codingblocks.net>, Michael Outlaw <michael@michaeloutlaw.com>
 * 
 * See the file license.txt for copying permission.
 */

using System;

namespace BadEIMIExamples
{
    public class SomeClass : IComparable
    {
        public Int32 SomeData { get; set; }

        // Marked as private by the compiler.
        //int IComparable.CompareTo(object obj)
        //{
        //    Console.WriteLine("SomeClass IComparable.CompareTo.");
        //    if (obj == null) return 1;

        //    var sc = obj as SomeClass;
        //    if (sc != null)
        //    {
        //        return SomeData.CompareTo(sc.SomeData);
        //    }
        //    else
        //    {
        //        throw new ArgumentException("Oops! That's not SomeClass!?");
        //    }
        //}

        // Marked as private by the compiler.
        int IComparable.CompareTo(object obj)
        {
            Console.WriteLine("SomeClass IComparable.CompareTo.");
            return CompareThis(obj);
        }

        public virtual int CompareThis(object obj)
        {
            //return ((IComparable)this).CompareTo(obj);
            Console.WriteLine("SomeClass CompareThis.");
            if (obj == null) return 1;

            var sc = obj as SomeClass;
            if (sc != null)
            {
                return SomeData.CompareTo(sc.SomeData);
            }
            else
            {
                throw new ArgumentException("Oops! That's not SomeClass!?");
            }
        }
    }
}
