﻿/*
 * Copyright (c) 2013 CodingBlocks.NET <http://codingblocks.net>, Michael Outlaw <michael@michaeloutlaw.com>
 * 
 * See the file license.txt for copying permission.
 */

using System;

namespace BadEIMIExamples
{
    public class SomeFinalChildClass : SomeClass, IComparable
    {
        public int CompareTo(object obj)
        {
            // We want to call the parent, but unfortunately, this method isn't an option
            // because base.CompareTo is marked as private.
            // return base.CompareTo(obj);

            // be careful....
            //Console.WriteLine("SomeFinalChildClass call to IComparable.CompareTo creates an infinite loop!");
            //return ((IComparable)this).CompareTo(obj);

            Console.WriteLine("SomeFinalChildClass calls base.CompareThis.");
            return base.CompareThis(obj);
        }

        public override int CompareThis(object obj)
        {
            Console.WriteLine("If we need to do something different...");
            return 0;
        }
    }
}
